您的位置:首页 > 其它

LeetCode:First Bad Version

2016-07-09 22:32 260 查看


First Bad Version

Total Accepted: 50887
Total Submissions:222393
Difficulty: Easy

You are a product manager and currently leading a team to develop a new product. Unfortunately,
the latest version of your product fails the quality check. Since each version is developed based on the previous version,
all the versions after a bad version are also bad.
Suppose you have
n
versions
[1,
2, ..., n]
and you want to find out the first bad one,
which causes all the following ones to be bad.
You are given an API
bool isBadVersion(version)
which
will return whether
version
is bad.
Implement a function to find the first bad version. You should minimize the number of calls to the API.
Credits:

Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

Subscribe to see which companies asked this question

Hide Tags
Binary Search

Hide Similar Problems
(M) Search for a Range (M)
Search Insert Position

思路:

二分查找。但是直接用mid = (lo + hi) / 2,可能会溢出。

因此等式替换为:mid = lo + (hi - lo) / 2,可防止溢出。

java code:

/* The isBadVersion API is defined in the parent class VersionControl.
boolean isBadVersion(int version); */

public class Solution extends VersionControl {
public int firstBadVersion(int n) {

int lo = 1, hi = n;

while(lo <= hi) {
int mid  = lo + ((hi - lo)>>1); // 防溢出
if(isBadVersion(mid))
hi = mid - 1;
else
lo = mid + 1;
}

return lo;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: